Name:           uthash
Version:        2.3.0
Release:    1%{?dist}
Summary:        A hash table for C structures

License:        BSD
URL:            http://troydhanson.github.io/%{name}
Source0:        https://github.com/troydhanson/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  asciidoc
BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  perl-interpreter
BuildRequires:  perl(strict)
BuildRequires:  perl(warnings)

%description
Any C structure can be stored in a hash table using uthash.  Just
add a UT_hash_handle to the structure and choose one or more fields
in your structure to act as the key.  Then use these macros to store,
retrieve or delete items from the hash table.


%package devel
Summary:        A hash table for C structures (headers only)


Provides:       %{name}        = %{version}-%{release}
Provides:       %{name}-static = %{version}-%{release}
Provides:       libut          = %{version}-%{release}
Provides:       libut-devel    = %{version}-%{release}

BuildArch:      noarch

%description devel
Any C structure can be stored in a hash table using uthash.  Just
add a UT_hash_handle to the structure and choose one or more fields
in your structure to act as the key.  Then use these macros to store,
retrieve or delete items from the hash table.


%package tools
Summary:        Command-line utilities for %{name}
Requires:       %{name}        = %{version}-%{release}

%description tools
This package provides the hashscan and keystats utility programs
for %{name}.

The hashscan program examines a running process and reports on the
uthash tables that it finds in that program’s memory.  It can also
save the keys from each table in a format that can be fed into keystats.

The keystats program is able to analyze which hash function has the best
characteristics on the set of keys reported by the hashscan program.


%package doc
Summary:        Documentation-files for %{name}
BuildArch:      noarch
Requires:       %{name}        = %{version}-%{release}

%description doc
This package contains the documentation-files for %{name}.


%prep
%autosetup -p1


%build
%set_build_flags
%make_build -C doc
%make_build -C tests
%make_build -C tests/threads


%install
mkdir -p %{buildroot}{%{_bindir},%{_includedir},%{_pkgdocdir}/html}
install -pm 0755 tests/{hashscan,keystats} %{buildroot}%{_bindir}
install -pm 0644 src/*.h %{buildroot}%{_includedir}
install -pm 0644 doc/*.txt tests/example.c %{buildroot}%{_pkgdocdir}
install -pm 0644 doc/*.html doc/*.css doc/*.png %{buildroot}%{_pkgdocdir}/html
rm -f %{buildroot}%{_pkgdocdir}/html/google*.html


%files devel
%license LICENSE
%doc %dir %{_pkgdocdir}
%doc %{_pkgdocdir}/ChangeLog.txt
%{_includedir}/*.h


%files tools
%{_bindir}/*


%files doc
%doc %{_pkgdocdir}


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.3.0-1
- initial build
